-- jpeg

-- ̓f[^
local jpeg = {q = {}, huffman = {}, frame = {}, scan  = {}}

-- rbgǂݍ
function RECEIVE(SSSS)
	return gbit(SSSS)
end

-- }0̓lƂĈ
function EXTEND(V, T)
	local Vt = 2^(T-1)
	if V < Vt then
		Vt = ((-1)<<T) + 1
		V = V+Vt
	end
	return V
end

-- nt}fR[h
function read_huffman(huffval, maxcode, mincode, valptr)
	local i=1
	local code = gbit(1) 
	while true do
		if maxcode[i] == nil then 
			print_table(maxcode)
			print(i, binstr(code))
		end
		if code > maxcode[i] then
			i = i + 1
			code = (code << 1) + gbit(1)
		else
			break
		end
	end
	local j = valptr[i]
	j = j + code - mincode[i]
	if huffval[j] == nil then
		assert(false)
	end
	return huffval[j]
end

-- ubN0
function init8x8(frame, block)
	for i=0, 63 do
		frame.macroblock[block][i] = 0
	end
end

-- DCnt}fR[h
function dcdiff8x8(frame, block)
	local T = read_huffman(
		frame.dc_huffval, frame.dc_maxcode, frame.dc_mincode, frame.dc_valptr)
	sprint("d", T)
	local DIFF = EXTEND(RECEIVE(T), T)
	local val = frame.dc_prev_diff + DIFF
	frame.macroblock[block][0] = val
	frame.dc_prev_diff = val
end

-- ACnt}fR[h
function ac8x8(frame, block)
	-- AC
	local K = 1
	while true do	
			sprint("a")
		local RS = read_huffman(
			frame.ac_huffval, frame.ac_maxcode, frame.ac_mincode, frame.ac_valptr)
		local RRRR = RS >> 4 -- 4bit͒l̑OZeroRunLength SSSSRRRR=0EOB
		local SSSS = RS % 16 -- 4bit͒l̃TCY, 0̏ꍇRRRRɂZRL or EOB or I[܂0
		local R = RRRR
		sprint("K=", K, "RRRR=", RRRR, "SSSS", SSSS)
		-- 0
		-- or l
		if SSSS == 0 then
			if R == 15 then
				-- ZRL
				K = K + 16
				sprint("ZRL")
			else
				sprint("EOB")
				break
			end
		else
			K = K + R
			frame.macroblock[block][K] = RECEIVE(SSSS)
			frame.macroblock[block][K] = EXTEND(frame.macroblock[block][K], SSSS)
			if K >= 63 then
				sprint("BREAK")
				break
			else
				K=K+1
			end
		end
	end
end

-- WOUOXL
local zigzag = {
	 0,  1,  8, 16,  9,  2,  3, 10,
	17, 24, 32, 25, 18, 11,  4,  5,
	12, 19, 26, 33, 40, 48, 41, 34,
	27, 20, 13,  6,  7, 14, 21, 28,
	35, 42, 49, 56, 57, 50, 43, 36,
	29, 22, 15, 23, 30, 37, 44, 51,
	58, 59, 52, 45, 38, 31, 39, 46,
	53, 60, 61, 54, 47, 55, 62, 63
}
function zigzag8x8(frame, block)
	local ZZ = frame.macroblock[block]
	frame.macroblock[block] = {}
	for i=0, 63 do
		frame.macroblock[block][zigzag[i+1]] = ZZ[i]
	end
end

-- tʎq
local function iquontization8x8(frame, block)
	for i=0, 63 do
		frame.macroblock[block][i] = frame.macroblock[block][i] * frame.q[i]
	end
end

-- s̊|Z(IDCTŎg)
function mul8x8(a, b)
	local ret = {}
	local ix
	for i=0, 7 do
		for j=0, 7 do
			ix = (i*8)+j 
			ret[ix] = 0
			for k=0, 7 do
				ret[ix] = ret[ix] + a[(i*8)+k] * b[(k*8)+j]
			end
		end
	end
	return ret
end

-- IDCT(Ȃ)
local dct_matrix = {}
local dct_matrix_t = {}
for i=0, 7 do
	dct_matrix[i] = 1/(2*(2^0.5))
	dct_matrix_t[i*8] = 1/(2*(2^0.5))
end
for i=1, 7 do
	for j=0, 7 do
		local v = 0.5 * math.cos(( i*(j+0.5) / 8) * math.pi)
		dct_matrix  [(i*8)+j] = v
		dct_matrix_t[(j*8)+i] = v
	end
end
function idct8x8(frame, block)
	frame.macroblock[block] = mul8x8(dct_matrix_t, frame.macroblock[block])
	frame.macroblock[block] = mul8x8(frame.macroblock[block], dct_matrix)
	for i=0, 63 do
		local v = math.ceil(frame.macroblock[block][i] + 128)
		if v < 0 then
			frame.macroblock[block][i] = 0
		elseif v > 255 then
			frame.macroblock[block][i] = 255
		else
			frame.macroblock[block][i] = v
		end
	end
end

-- 8x8ubNfobO\
function dump8x8(t)
	for i = 1, 8 do
		for j = 1, 8  do
			io.write(string.format("%7.2f ", t[8*(i-1) + (j-1)]))
		end
		io.write("\n")
	end
end

-- Y16x164:2:0rbg}bvɏ
local c420_indices = 
{
	 0, 0, 1, 1, 2, 2, 3, 3,
	 0, 0, 1, 1, 2, 2, 3, 3,
	 8, 8, 9, 9,10,10,11,11,
	 8, 8, 9, 9,10,10,11,11,
	16,16,17,17,18,18,19,19,
	16,16,17,17,18,18,19,19,
	24,24,25,25,26,26,27,27,
	24,24,25,25,26,26,27,27
}
function fill_block_420(bmp, x, y, Y, Cb, Cr)	
	local yix = 0
	local block = 1
	local cix = 0
	local coff = 0
	for bi = 0, 8, 8 do
		for bj = 0, 8, 8 do
			yix = 0
			for i=0, 7 do
				for j=0, 7 do
					bmp:putyuv(x+bj+j, y+bi+i,
						Y[block][yix],
						Cb[c420_indices[yix+1]+coff],
						Cr[c420_indices[yix+1]+coff])
					yix = yix + 1 
				end
			end
			block = block + 1
			coff = coff + 4
		end
		coff = coff + 24
	end
end

-- Y16x84:2:0rbg}bvɏ
local c422_indices = 
{
	 0, 0, 1, 1, 2, 2, 3, 3,
	 8, 8, 9, 9,10,10,11,11,
	16,16,17,17,18,18,19,19,
	24,24,25,25,26,26,27,27,
	32,32,33,33,34,34,35,35,
	40,40,41,41,42,42,43,43,
	48,48,49,49,50,50,51,51,
	56,56,57,57,58,58,59,59
}
function fill_block_422(bmp, x, y, Y, Cb, Cr)	
	local yix = 0
	local block = 1
	local cix = 0
	local coff = 0
	for bj = 0, 8, 8 do
		yix = 0
		for i=0, 7 do
			for j=0, 7 do
				bmp:putyuv(x+bj+j, y+i,
					Y[block][yix],
					Cb[c422_indices[yix+1]+coff],
					Cr[c422_indices[yix+1]+coff])
				yix = yix + 1 
			end
		end
		block = block + 1
		coff = coff + 4
	end
end

-- Y8x84:4:4rbg}bvɏ
function fill_block_444(bmp, x, y, Y, Cb, Cr)
	local yix = 0
	for bi=0, 7 do
		for bj=0, 7 do
			bmp:putyuv(x+bj, y+bi, Y[yix], Cb[yix], Cr[yix])
			yix = yix + 1 
		end
	end
end

-- sN`f[^XLEfR[h
function start_scan()
	-- f[^]
	local scan, prev = open()
	swap(prev)
	while true do
		local ofs = fbyte(0xff, 0x7fffffff, false)
		tbyte("scan", ofs, scan, true)
		local segment = lbyte(2)
		if segment == 0xffd0
		or segment == 0xffd1
		or segment == 0xffd2
		or segment == 0xffd3
		or segment == 0xffd4
		or segment == 0xffd5
		or segment == 0xffd6
		or segment == 0xffd7 then
			-- reset
			tbyte("RST", 2, scan, true)
		elseif segment ~= 0xff00 then
			break
		else
			tbyte("scan", 1, scan, true)
			cbyte("dummy", 1, 0)
		end
	end
	swap(scan)
	
	repeat
		-- XLp̃e[up
		local hi
		local vi
		for i=1, jpeg.num_frame do
			jpeg.frame[i].q = jpeg.q[jpeg.frame[i].Qi]
			jpeg.frame[i].dc_huffval  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][0].huffval
			jpeg.frame[i].dc_huffcode = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][0].huffcode
			jpeg.frame[i].dc_mincode  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][0].mincode 
			jpeg.frame[i].dc_maxcode  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][0].maxcode 
			jpeg.frame[i].dc_valptr   = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][0].valptr  
		
			jpeg.frame[i].ac_huffval  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].dc_huffman][1].huffval
			jpeg.frame[i].ac_huffcode = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].ac_huffman][1].huffcode
			jpeg.frame[i].ac_mincode  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].ac_huffman][1].mincode 
			jpeg.frame[i].ac_maxcode  = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].ac_huffman][1].maxcode 
			jpeg.frame[i].ac_valptr   = jpeg.huffman[jpeg.scan[jpeg.frame[i].Ci].ac_huffman][1].valptr

			jpeg.frame[i].dc_prev_diff = 0
			jpeg.frame[i].macroblock = {{}, {}, {}, {}}
			
			if jpeg.frame[i].Ci == 1 then
				hi = jpeg.frame[i].Hi
				vi = jpeg.frame[i].Vi
			end
		end
		
		if hi == 2 and vi == 2 then
		elseif hi == 2 and vi == 1 then
		elseif hi == 1 and vi == 1 then
			-- supported
		else
			print("unsupported color format")
			break
		end
		
		-- fR[h
		local x = 0
		local y = 0
		local macroblocksize_x = hi*8
		local macroblocksize_y = vi*8 
		local buf_width  = math.ceil(jpeg.width / macroblocksize_x) * macroblocksize_x
		local buf_height = math.ceil(jpeg.height / macroblocksize_y) * macroblocksize_y
		local reset_count = 0
		local RST
		local bmp = bitmap:new(jpeg.width, jpeg.height, buf_width, buf_height)
		print("W = "..jpeg.width)
		print("H = "..jpeg.height)
		print("Start Decode ..")
		while y < buf_height do
			while x < buf_width do
				check_progress(false)
				
				-- Zbg
				if jpeg.restert_interval and reset_count >= jpeg.restert_interval then
					if select(2, cur()) ~= 0 then
						rbit("stuffing_bit", 8 - select(2, cur()))
					end
					RST = rbyte("RST", 2)
					if  RST ~= 0xffd0
					and RST ~= 0xffd1
					and RST ~= 0xffd2
					and RST ~= 0xffd3
					and RST ~= 0xffd4
					and RST ~= 0xffd5
					and RST ~= 0xffd6
					and RST ~= 0xffd7 then
						assert(false, "failed reset.")
					else
						print("reset marker", hexstr(RST))
						for i, v in ipairs(jpeg.frame) do
							v.dc_prev_diff = 0
						end
					end
					reset_count = 1
				else
					reset_count = reset_count + 1
				end
				
				-- }NubNfR[h
				for ci, v in ipairs(jpeg.frame) do
					local block = 1
					for i = 0, v.Vi-1 do
						for j = 0, v.Hi-1 do
							-- 8x8fR[h
							sprint("8x8", ci, i, j)
							init8x8(v, block)
							dcdiff8x8(v, block)
							ac8x8(v, block)
							iquontization8x8(v, block)
							zigzag8x8(v, block)
							idct8x8(v, block)
							block = block + 1
						end
					end
				end
				
				-- bitmapɏ
				if hi == 2 and vi == 2 then
					fill_block_420(bmp, x, y,
						jpeg.frame[1].macroblock,
						jpeg.frame[2].macroblock[1],
						jpeg.frame[3].macroblock[1])	
				elseif hi == 2 and vi == 1 then
					fill_block_422(bmp, x, y,
						jpeg.frame[1].macroblock,
						jpeg.frame[2].macroblock[1],
						jpeg.frame[3].macroblock[1])
				else
					fill_block_444(bmp, x, y,
						jpeg.frame[1].macroblock[1],
						jpeg.frame[2].macroblock[1],
						jpeg.frame[3].macroblock[1])
				end				
				x = x + macroblocksize_x
			end
			x = 0
			y = y + macroblocksize_y
		end
		print("Done")
		
		-- t@CER\[o
		bmp:write(__out_dir__..__stream_name__..".bmp")
		local sb = bmp:create_scaled_bmp(120, nil)
		sb:print_ascii(120, nil)
	until true

	swap(prev)
end

-- mȂZOgǂݔ΂
function segment()
	local length = rbit("L", 16)
	seekoff(length - 2)
end

-- ȉJPEGKiʂ

function app0()
	local begin = cur()
	print("-------------------JFIF-------------------")
	rbyte("L" ,         2)
	cstr ("identifier", 5, "4A 46 49 46 00")
	rbyte("version",    2)
	rbyte("units",      1)
	rbyte("Xdensity",   2)
	rbyte("Ydensity",   2)
	rbyte("Xthumbnail", 1)
	rbyte("Ythumbnail", 1)
	rbyte("(RGB)",      3 * get("Xthumbnail")*get("Ythumbnail"))

	seekoff(get("L") - (cur() - begin))
end

function app1()
	local begin = cur()
	rbyte("L",               2)
	rstr ("Identifier",      4)

	if get("Identifier") == "Exif" then
		print("-------------------Exif-------------------")
		rbyte("0000",                2)
		exif()
	elseif get("Identifier") == "http" then
		print("-------------------Http-------------------")
		rstr("http",             256)
	end
	skip(get("L"), begin)
end

function dqt()
print("Quantization table")
	local begin = cur()

	rbit("Lq", 16)
	
	repeat
		rbit("Pq", 4)
		rbit("Tq", 4)

		local precision = get("Pq") == 0 and 8 or 16
		local Q = {}
		for i=0, 63 do
			Q[i] = rbit("Qk", precision)
		end
		
		jpeg.q[get("Tq")] = Q
	until get("Lq") <= cur()-begin
end

function dri()
print("Define restert interbal ")
	local begin = cur()
	rbit("Lr", 16)
	rbit("Ri", 16) -- X^[gC^[o

	jpeg.restert_interval = get("Ri")  

	skip(get("Lr"), begin)
end

function dht()
print("Huffman table")

	local begin = cur()
	rbit("Lh", 16)

	repeat
		rbit("Tc", 4) -- ̃e[uĝDCAC
		rbit("Th", 4) -- ̃e[uID

		local BITS = {}
		local V = {}
		for i=1, 16 do
			BITS[i] = rbit("Li",        8)
		end
		local k = 0
		for i=1, 16 do
			sprint("V["..i.."]")
			for j=1, BITS[i] do
				V[k] = rbit("Vij",      8)
				k = k + 1
			end
		end

		-- huffsize
		local k = 0
		local huffsize = {}
		for i=1, 16 do
			for j = 1, BITS[i] do
				huffsize[k] = i
				k = k + 1
			end
		end
		huffsize[k] = 0
		
		-- huffcode
		k = 0
		local code = 0
		local si = huffsize[0]
		local huffcode = {}
		while true do
			while huffsize[k] == si do
				huffcode[k] = code
				-- printf("%10s, %-16s %-32s", k, "val="..V[k], "huff=="..binstr(code, si))
				code = code + 1
				k = k + 1
			end

			if huffsize[k] == 0 then
				break
			end

			while huffsize[k] ~= si do
				code = code << 1 -- 11111 ̏Ԃ獶Vtg
				si = si + 1
			end
		end
		
		-- max min valptr
		local maxcode = {} -- bit̃nt}R[h̍ől
		local mincode = {} -- bit̃nt}R[h̍ől
		local valptr = {}  -- mincodeindex
		local j = 0
		for i = 1, 16 do
			if BITS[i] == 0 then
				maxcode[i] = -1
			else
				valptr[i] = j
				mincode[i] = huffcode[j]
				j = j + BITS[i] - 1
				maxcode[i] = huffcode[j]
				j = j + 1
			end
		end
		
		jpeg.huffman[get("Th")] = jpeg.huffman[get("Th")] or {}
		jpeg.huffman[get("Th")][get("Tc")] = {}
		jpeg.huffman[get("Th")][get("Tc")].huffval  = V
		jpeg.huffman[get("Th")][get("Tc")].huffcode = huffcode
		jpeg.huffman[get("Th")][get("Tc")].mincode  = mincode
		jpeg.huffman[get("Th")][get("Tc")].maxcode  = maxcode
		jpeg.huffman[get("Th")][get("Tc")].valptr   = valptr

	until get("Lh") <= cur()-begin
end

function sof0()
print("Frame header")

	local begin = cur()
	rbit("Lf", 16)
	rbit("P",  8)
	rbit("Y",  16)
	rbit("X",  16)
	rbit("Nf", 8)
	
	printf("w=%d h=%d", get("X"), get("Y"))
	jpeg.width = get("X")
	jpeg.height = get("Y")
	jpeg.num_frame = get("Nf")

	for i=1, get("Nf") do
		local ci =
		rbit("Ci",  8) -- Component(Y, Cb, Cr or etc)
		rbit("Hi",  4) -- factor h
		rbit("Vi",  4) -- factor v
		rbit("Tqi", 8) -- table

		local ci = get("Ci")
		if     ci == 1 then printf("# Y  h=%d v=%d", get("Hi"), get("Vi"))
		elseif ci == 2 then printf("# Cb h=%d v=%d", get("Hi"), get("Vi"))
		elseif ci == 3 then printf("# Cr h=%d v=%d", get("Hi"), get("Vi"))
		elseif ci == 4 then printf("# I  h=%d v=%d", get("Hi"), get("Vi"))
		elseif ci == 5 then printf("# Q  h=%d v=%d", get("Hi"), get("Vi"))
		else assert(false, "unknown Ci") end

		jpeg.frame[i] = {}
		jpeg.frame[i].Qi = get("Tqi")
		jpeg.frame[i].Hi = get("Hi")
		jpeg.frame[i].Vi = get("Vi")
		jpeg.frame[i].Ci = get("Ci")
	end

	skip(get("Lf"), begin)
end

function sos()
print("Scan header")
	local begin = cur()
	
	rbit("Ls", 16)
	rbit("Ns", 8)

	for i=1, get("Ns") do
		rbit("Csj", 8) -- ID
		rbit("Tdj", 4) -- cbnt}e[uԍ
		rbit("Taj", 4) -- `bnt}e[uԍ

		jpeg.scan[get("Csj")] = {}
		jpeg.scan[get("Csj")].dc_huffman = get("Tdj") 
		jpeg.scan[get("Csj")].ac_huffman = get("Taj") 
	end

	rbit("Ss", 8)
	rbit("Se", 8)
	rbit("Ah", 4)
	rbit("AL", 4)

	skip(get("Ls"), begin)
	
	--XLfR[hJn
	start_scan()
end

function get_type(t)
	if     t == 1   then return 1, "byte"
	elseif t == 2   then return 1, "ascii"
	elseif t == 3   then return 2, "short"
	elseif t == 4   then return 4, "long"
	elseif t == 5   then return 8, "rational"
	elseif t == 7   then return 1, "undefined"
	elseif t == 9   then return 4, "slong"
	elseif t == 10  then return 8, "srational"
	end
end

-- Exif̈於擾
function get_tag(t)
	if     t == 0       then return "GPSVersionID"                ,"GPS^Õo[W                   :"
	elseif t == 1       then return "GPSLatitudeRef"              ,"ܓx̓k                            :"
	elseif t == 2       then return "GPSLatitude"                 ,"ܓxixAAbj                    :"
	elseif t == 3       then return "GPSLongitudeRef"             ,"ox̓                            :"
	elseif t == 4       then return "GPSLongitude"                ,"oxixAAbj                    :"
	elseif t == 5       then return "GPSAltitudeRef"              ,"x̊                            :"
	elseif t == 6       then return "GPSAltitude"                 ,"ximj                             :"
	elseif t == 7       then return "GPSTimeStamp"                ,"GPS̎ԁiqvj                 :"
	elseif t == 8       then return "GPSSatellites"               ,"ʂɎgpGPSq                 :"
	elseif t == 9       then return "GPSStatus"                   ,"GPSM@̏                       :"
	elseif t == 10      then return "GPSMeasureMode"              ,"GPS̑ʃ[h                       :"
	elseif t == 11      then return "GPSDOP"                      ,"ʂ̐M                          :"
	elseif t == 12      then return "GPSSpeedRef"                 ,"x̒P                            :"
	elseif t == 13      then return "GPSSpeed"                    ,"x                                  :"
	elseif t == 14      then return "GPSTrackRef"                 ,"is̊                        :"
	elseif t == 15      then return "GPSTrack"                    ,"isixj                        :"
	elseif t == 16      then return "GPSImgDirectionRef"          ,"Be̊                        :"
	elseif t == 17      then return "GPSImgDirection"             ,"Beixj                        :"
	elseif t == 18      then return "GPSMapDatum"                 ,"ʂɗpn}f[^                :"
	elseif t == 19      then return "GPSDestLatitudeRef"          ,"ړIn̈ܓx̓k                    :"
	elseif t == 20      then return "GPSDestLatitude"             ,"ړIn̈ܓxixAAbj            :"
	elseif t == 21      then return "GPSDestLongitudeRef"         ,"ړIňox̓                    :"
	elseif t == 22      then return "GPSDestLongitude"            ,"ړIňoxixAAbj            :"
	elseif t == 23      then return "GPSBearingRef"               ,"ړIn̕p̊                    :"
	elseif t == 24      then return "GPSBearing"                  ,"ړIn̕pixj                    :"
	elseif t == 25      then return "GPSDestDistanceRef"          ,"ړInւ̋̒P                  :"
	elseif t == 26      then return "GPSDestDistance"             ,"ړInւ̋                        :"
	elseif t == 256     then return "ImageWidth"                  ,"摜̕                              :"
	elseif t == 257     then return "ImageLength"                 ,"摜̍                            :"
	elseif t == 258     then return "BitsPerSample"               ,"摜̃rbg̐[                    :"
	elseif t == 259     then return "Compressionk̎"       ,"Compression scheme                    :"
	elseif t == 262     then return "PhotometricInterpretation"   ,"摜                            :"
	elseif t == 270     then return "ImageDescription"            ,"摜^Cg                          :"
	elseif t == 271     then return "Make"                        ,"摜͋@̃[J[              :"
	elseif t == 272     then return "Model"                       ,"摜͋@̃f                :"
	elseif t == 273     then return "StripOffsets"                ,"摜f[^̃P[V              :"
	elseif t == 274     then return "Orientation"                 ,"摜                              :"
	elseif t == 277     then return "SamplesPerPixel"             ,"R|[lg                      :"
	elseif t == 278     then return "RowsPerStrip"                ,"XgbṽC                :"
	elseif t == 279     then return "StripByteCounts"             ,"Xgbṽf[^                  :"
	elseif t == 282     then return "XResolution"                 ,"摜̉̕𑜓x                      :"
	elseif t == 283     then return "YResolution"                 ,"摜̍̉𑜓x                    :"
	elseif t == 284     then return "PlanarConfiguration"         ,"摜f[^̕                      :"
	elseif t == 296     then return "ResolutionUnit"              ,"摜̕ƍ̉𑜓x̒P          :"
	elseif t == 301     then return "TransferFunction"            ,"ĐKJ[u                    :"
	elseif t == 305     then return "CreatorTool"                 ,"gpSoftware                        :"
	elseif t == 306     then return "ModifyDate"                  ,"t@CύX                      :"
	elseif t == 315     then return "Artist"                      ,"Җ                                :"
	elseif t == 318     then return "WhitePoint"                  ,"QƔF_̐FxWl                :"
	elseif t == 319     then return "PrimaryChromaticities"       ,"F̐FxWl                      :"
	elseif t == 513     then return "JPEGInterchangeFormat"       ,"JPEG  SOI ւ̃ItZbg            :"
	elseif t == 514     then return "JPEGInterchangeFormatLength" ,"JPEG f[^̃oCg                 :"
	elseif t == 529     then return "YCbCrCoefficients"           ,"Fϊ}gNXW                  :"
	elseif t == 530     then return "YCbCrSubSampling"            ,"YCC ̉f (C̊Ԉ)        :"
	elseif t == 531     then return "YCbCrPositioning"            ,"YCC ̉f (Y  C ̈ʒu)      :"
	elseif t == 532     then return "ReferenceBlackWhite"         ,"QƍF_lƎQƔF_l            :"
	elseif t == 33432   then return "Copyright"                   ,"Be쌠/ҏW쌠             :"
	elseif t == 33434   then return "ExposureTime"                ,"Io                              :"
	elseif t == 33437   then return "FNumber"                     ,"Fl                                   :"
	elseif t == 34665   then return "ExifIFDPointer"              ,"Exif ^O                             :"
	elseif t == 34850   then return "ExposureProgram"             ,"IovO                        :"
	elseif t == 34852   then return "SpectralSensitivity"         ,"XyNgx                        :"
	elseif t == 34853   then return "GPSInfoIFDPointer"           ,"GPS ^O                              :"
	elseif t == 34855   then return "ISOSpeedRatings"             ,"ISO Xs[h[g/Bex           :"
	elseif t == 34856   then return "OECF"                        ,"d֐                          :"
	elseif t == 36864   then return "ExifVersion"                 ,"Exif o[W                       :"
	elseif t == 36867   then return "DateTimeOriginal"            ,"摜f[^̐                :"
	elseif t == 36868   then return "MetadataDate"                ,"fW^f[^̐              :"
	elseif t == 37121   then return "ComponentsConfiguration"     ,"eR|[lg̈Ӗ                :"
	elseif t == 37122   then return "CompressedBitsPerPixel"      ,"摜k[h                        :"
	elseif t == 37377   then return "ShutterSpeedValue"           ,"Vb^[Xs[h                    :"
	elseif t == 37378   then return "ApertureValue"               ,"il                                :"
	elseif t == 37379   then return "BrightnessValue"             ,"Pxl                                :"
	elseif t == 37380   then return "ExposureBiasValue"           ,"Io␳l                            :"
	elseif t == 37381   then return "MaxApertureValue"            ,"Yŏ F l                       :"
	elseif t == 37382   then return "SubjectDistance"             ,"ʑ̋                            :"
	elseif t == 37383   then return "MeteringMode"                ,"                              :"
	elseif t == 37384   then return "LightSource"                 ,"                                  :"
	elseif t == 37385   then return "Flash"                       ,"tbV                            :"
	elseif t == 37386   then return "FocalLength"                 ,"Yœ_                        :"
	elseif t == 37396   then return "SubjectArea"                 ,"Subject area                          :"
	elseif t == 37500   then return "MakerNote"                   ,"[J[m[g                        :"
	elseif t == 37510   then return "UserComment"                 ,"[U[Rg                      :"
	elseif t == 37520   then return "SubSecTime"                  ,"Date Time ̃TuZbN                :"
	elseif t == 37521   then return "SubSecTimeOriginal"          ,"Date Time Original ̃TuZbN       :"
	elseif t == 37522   then return "SubSecTimeDegitized"         ,"Date Time Digitized ̃TuZbN      :"
	elseif t == 40960   then return "FlashpixVersion"             ,"ΉtbVsbNXo[W      :"
	elseif t == 40961   then return "ColorSpace"                  ,"Fԏ                            :"
	elseif t == 40962   then return "PixelXDimension"             ,"摜                            :"
	elseif t == 40963   then return "PixelYDimension"             ,"摜                          :"
	elseif t == 40964   then return "RelatedSoundFile"            ,"֘At@C                      :"
	elseif t == 40965   then return "InteroperabilityIFDPointer"  ,"݊ IFD ւ̃|C^               :"
	elseif t == 41483   then return "FlashEnergy"                 ,"tbVx                        :"
	elseif t == 41484   then return "SpatialFrequencyResponse"    ,"Ԏg                        :"
	elseif t == 41486   then return "FocalPlaneXResolution"       ,"œ_ʂ̉̕𑜓x                    :"
	elseif t == 41487   then return "FocalPlaneYResolution"       ,"œ_ʂ̍̉𑜓x                  :"
	elseif t == 41488   then return "FocalPlaneResolutionUnit"    ,"œ_ʉ𑜓xP                      :"
	elseif t == 41492   then return "SubjectLocation"             ,"ʑ̈ʒu                            :"
	elseif t == 41493   then return "ExposureIndex"               ,"IoCfbNX                      :"
	elseif t == 41495   then return "SensingMethod"               ,"ZT[                          :"
	elseif t == 41728   then return "FileSource"                  ,"FileSource                            :"
	elseif t == 41729   then return "SceneType"                   ,"V[^Cv                          :"
	elseif t == 41730   then return "CFAPattern"                  ,"CFA p^[                          :"
	elseif t == 41985   then return "CustomRendered"              ,"JX^C[WvZbVO        :"
	elseif t == 41986   then return "ExposureMode"                ,"Io[h                            :"
	elseif t == 41987   then return "WhiteBalance"                ,"zCgoX                      :"
	elseif t == 41988   then return "DigitalZoomRatio"            ,"fW^Y[䗦                    :"
	elseif t == 41989   then return "FocalLengthIn35mmFilm"       ,"35mm Zœ_                     :"
	elseif t == 41990   then return "SceneCaptureType"            ,"V[Be^Cv                      :"
	elseif t == 41991   then return "GainControl"                 ,"QCRg[                    :"
	elseif t == 41992   then return "Contrast"                    ,"RgXg                          :"
	elseif t == 41993   then return "Saturation"                  ,"ʓx                                  :"
	elseif t == 41994   then return "Sharpness"                   ,"V[vlX                          :"
	elseif t == 41995   then return "DeviceSettingDescription"    ,"foCXݒ                          :"
	elseif t == 41996   then return "SubjectDistanceRange"        ,"ʑ͈̋                        :"
	elseif t == 42016   then return "0xa420"                      ,"j[N摜 ID                       :"
	elseif t == 42240   then return "0xa500"                      ,"K}l                              :"
	elseif t == 50706   then return "DNGVersion"                  ,"DNG o[W                        :"
	elseif t == 50707   then return "DNGBackwardVersion"          ,"DNG backward version                  :"
	elseif t == 50708   then return "DNGUniqueCameraModel"        ,"J@햼                          :"
	elseif t == 50709   then return "DNGLocalizedCameraModel"     ,"J@햼                          :"
	elseif t == 50710   then return "DNGCFAPlaneColor"            ,"CFA plane color                       :"
	elseif t == 50711   then return "DNGCFALayout"                ,"CFA CAEg                        :"
	elseif t == 50712   then return "DNGLinearizationTable"       ,"Linearization table                   :"
	elseif t == 50713   then return "DNGBlackLevelRepeatDim"      ,"Black level repeat dim                :"
	elseif t == 50714   then return "DNGBlackLevel"               ,"Black level                           :"
	elseif t == 50715   then return "DNGBlackLevelDeltaH"         ,"Black level delta H                   :"
	elseif t == 50716   then return "DNGBlackLevelDeltaV"         ,"Black level delta V                   :"
	elseif t == 50717   then return "DNGWhiteLevel"               ,"White level                           :"
	elseif t == 50718   then return "DNGDefaultscale"             ,"Default scale                         :"
	elseif t == 50719   then return "DNGDefaultCropOrigin"        ,"Default crop origin                   :"
	elseif t == 50720   then return "DNGDefaultCropSize"          ,"Default crop size                     :"
	elseif t == 50721   then return "DNGColorMatrix1"             ,"Color matrix1                         :"
	elseif t == 50722   then return "DNGColorMatrix2"             ,"Color matrix2                         :"
	elseif t == 50723   then return "DNGCameraCalibration1"       ,"Camera calibration1                   :"
	elseif t == 50724   then return "DNGCameraCalibration2"       ,"Camera calibration2                   :"
	elseif t == 50725   then return "DNGReductionMatrix1"         ,"Reduction matrix1                     :"
	elseif t == 50726   then return "DNGReductionMatrix2"         ,"Reduction matrix2                     :"
	elseif t == 50727   then return "DNGAnalogBalance"            ,"Analog balance                        :"
	elseif t == 50728   then return "DNGAsShotNeutral"            ,"As shot neutral                       :"
	elseif t == 50729   then return "DNGAsShotWhiteXY"            ,"As shot white XY                      :"
	elseif t == 50730   then return "DNGBaselineExposure"         ,"Baseline exposure                     :"
	elseif t == 50731   then return "DNGBaselineNoise"            ,"Baseline noise                        :"
	elseif t == 50732   then return "DNGBaselineSharpness"        ,"Baseline sharpness                    :"
	elseif t == 50733   then return "DNGBayerGreenSplit"          ,"Bayer green split                     :"
	elseif t == 50734   then return "DNGLinearResponseLimit"      ,"Linear response limit                 :"
	elseif t == 50735   then return "DNGCameraSerialNumber"       ,"VAio[                      :"
	elseif t == 50736   then return "DNGLensInfo"                 ,"Y                            :"
	elseif t == 50737   then return "DNGChromaBlurRadius"         ,"Chroma blur radius                    :"
	elseif t == 50738   then return "DNGAntiAliasStrength"        ,"Anti-alias strength                   :"
	elseif t == 50739   then return "DNGShadowScale"              ,"Shadow scale                          :"
	elseif t == 50740   then return "DNGPrivateData"              ,"vCx[gf[^                    :"
	elseif t == 50741   then return "DNGMakerNoteSafety"          ,"MakerNote safety                      :"
	elseif t == 50778   then return "DNGCalibrationIlluminant1"   ,"Calibration illuminant1               :"
	elseif t == 50779   then return "DNGCalibrationIlluminant2"   ,"Calibration illuminant2               :"
	elseif t == 50780   then return "DNGBestQualityScale"         ,"Best quality scale                    :"
	elseif t == 50781   then return "DNGRawDataUniqueID"          ,"Raw data unique ID                    :"
	elseif t == 50827   then return "DNGOriginalRawFileName"      ,"IWi RAW t@C             :"
	elseif t == 50828   then return "DNGOriginalRawFileData"      ,"IWi RAW t@Cf[^         :"
	elseif t == 50829   then return "DNGActiveArea"               ,"Active area                           :"
	elseif t == 50830   then return "DNGMaskedArea"               ,"Masked area                           :"
	elseif t == 50831   then return "DNGAsShotICCProfile"         ,"As shot ICC profile                   :"
	elseif t == 50832   then return "DNGAsShotPreProfileMatrix"   ,"As shot pre-profile matrix            :"
	elseif t == 50833   then return "DNGCurrentICCProfile"        ,"Current ICC profile                   :"
	elseif t == 50834   then return "DNGCurrentPreProfileMatrix"  ,"Current pre-profile matrix            :"
	elseif t == 1000000 then return "GPSVersionID"                ,"GPS ^Õo[W                  :"
	elseif t == 1000001 then return "GPSLatitudeRef"              ,"k(N) or (S)                    :"
	elseif t == 1000002 then return "GPSLatitude"                 ,"ܓx (l)                           :"
	elseif t == 1000003 then return "GPSLongitudeRef"             ,"o(E) or o(W)                    :"
	elseif t == 1000004 then return "GPSLongitude"                ,"ox (l)                           :"
	elseif t == 1000005 then return "GPSAltitudeRef"              ,"x̒P                            :"
	elseif t == 1000006 then return "GPSAltitude"                 ,"x (l)                           :"
	elseif t == 1000007 then return "GPSTimeStamp"                ,"GPS  (qv̎)             :"
	elseif t == 1000008 then return "GPSSatellites"               ,"ʂɎgqM                  :"
	elseif t == 1000009 then return "GPSStatus"                   ,"GPS M@̏                      :"
	elseif t == 1000010 then return "GPSMessureMode"              ,"GPS ʕ@                          :"
	elseif t == 1000011 then return "GPSDOP"                      ,"ʂ̐M                          :"
	elseif t == 1000012 then return "GPSSpeedRef"                 ,"x̒P                            :"
	elseif t == 1000013 then return "GPSSpeed"                    ,"x (l)                           :"
	elseif t == 1000014 then return "GPSTrackRef"                 ,"is̒P                        :"
	elseif t == 1000015 then return "GPSTrack"                    ,"is (l)                       :"
	elseif t == 1000016 then return "GPSImgDirectionRef"          ,"Be摜̒̕P              :"
	elseif t == 1000017 then return "GPSImgDirection"             ,"Be摜̕ (l)             :"
	elseif t == 1000018 then return "GPSMapDatum"                 ,"ʗpn}f[^                  :"
	elseif t == 1000019 then return "GPSDestLatitudeRef"          ,"ړIn̖k(N) or (S)            :"
	elseif t == 1000020 then return "GPSDestLatitude"             ,"ړIn̈ܓx (l)                   :"
	elseif t == 1000021 then return "GPSDestLongitudeRef"         ,"ړIn̓o(E) or o(W)            :"
	elseif t == 1000022 then return "GPSDestLongitude"            ,"ړIňox (l)                   :"
	elseif t == 1000023 then return "GPSDestBearingRef"           ,"ړIn̕p̒P                    :"
	elseif t == 1000024 then return "GPSDestBearing"              ,"ړIn̕p (l)                   :"
	elseif t == 1000025 then return "GPSDestDistanceRef"          ,"ړIn܂ł̋̒P                :"
	elseif t == 1000026 then return "GPSDestDistance"             ,"ړIn܂ł̋ (l)               :"
	elseif t == 1000027 then return "GPSProcessingMethod"         ,"Name of GPS processing method         :"
	elseif t == 1000028 then return "GPSAreaInformation"          ,"Name of GPS area                      :"
	elseif t == 1000029 then return "GPSDateStamp"                ,"GPS date                              :"
	elseif t == 1000030 then return "GPSDifferential"             ,"GPS differential correction           :"
	elseif t == 2000000 then return "InteroperabilityIndex"       ,"݊ʎq                          :"
	elseif t == 3000001 then return "CRSRawFileName"              ,"Raw t@C                        :"
	elseif t == 3000002 then return "CRSVersion"                  ,"o[W                            :"
	elseif t == 3000003 then return "CRSWhiteBalance"             ,"zCgoX                      :"
	elseif t == 3000004 then return "CRSTemperature"              ,"Fx                                :"
	elseif t == 3000005 then return "CRSTint"                     ,"F                                :"
	elseif t == 3000006 then return "CRSShadowTint"               ,"ShadowTint                            :"
	elseif t == 3000007 then return "CRSExposure"                 ,"I                                :"
	elseif t == 3000008 then return "CRSShadows"                  ,"VhE                              :"
	elseif t == 3000009 then return "CRSBrightness"               ,"邳                                :"
	elseif t == 3000010 then return "CRSContrast"                 ,"RgXg                          :"
	elseif t == 3000011 then return "CRSSaturation"               ,"ʓx                                  :"
	elseif t == 3000012 then return "CRSRedSaturation"            ,"ʓx()                              :"
	elseif t == 3000013 then return "CRSGreenSaturation"          ,"ʓx()                              :"
	elseif t == 3000014 then return "CRSBlueSaturation"           ,"ʓx()                              :"
	elseif t == 3000015 then return "CRSSharpness"                ,"V[v                              :"
	elseif t == 3000016 then return "CRSLuminanceSmoothing"       ,"LuminanceSmoothing                    :"
	elseif t == 3000017 then return "CRSRedHue"                   ,"RedHue                                :"
	elseif t == 3000018 then return "CRSGreenHue"                 ,"GreenHue                              :"
	elseif t == 3000019 then return "CRSBlueHue"                  ,"BlueHue                               :"
	elseif t == 3000020 then return "CRSColorNoiseReduction"      ,"ColorNoiseReduction                   :"
	elseif t == 3000021 then return "CRSChromaticAberration"      ,"RChromaticAberration                  :"
	elseif t == 3000022 then return "CRSChromaticAberration"      ,"BChromaticAberration                  :"
	elseif t == 3000023 then return "CRSVignette"                 ,"AmountVignette                        :"
	elseif t == 3000024 then return "CRSLens"                     ,"Y                                :"
	elseif t == 3000025 then return "CRSSerialNumber"             ,"VAio[                      :"
	elseif t == 3000026 then return "CRSAutoBrightness"           ,"邳ݒ                        :"
	elseif t == 3000027 then return "CRSAutoShadows"              ,"VhEݒ                      :"
	elseif t == 3000028 then return "CRSAutoContrast"             ,"RgXgݒ                  :"
	elseif t == 3000029 then return "CRSAutoExposure"             ,"Iʎݒ                        :"
	elseif t == 3100512 then return "OLSpecialMode"               ,"Be[h                            :"
	elseif t == 3100513 then return "OLJpegQuality"               ,"Bei                              :"
	elseif t == 3100514 then return "OLMacro"                     ,"}N                                :"
	elseif t == 3100516 then return "OLDigitalZoom"               ,"fW^Y[                        :"
	elseif t == 3100519 then return "OLSoftwareRelease"           ,"t@[EFA                        :"
	elseif t == 3100520 then return "OLpictInfo"                  ,"摜                              :"
	elseif t == 3100521 then return "OLCameraID"                  ,"J ID                             :"
	elseif t == 3103840 then return "OLDataDump.unknown"          ,"Data dump                             :"
	elseif t == 3104100 then return "OLFlashMode"                 ,"tbV[h                      :"
	elseif t == 3104102 then return "OLExposureBias"              ,"Io␳l                            :"
	elseif t == 3104107 then return "OLFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 3104108 then return "OLFocusDistance"             ,"œ_                              :"
	elseif t == 3104109 then return "OLZoom"                      ,"Y[                                :"
	elseif t == 3104110 then return "OLMacroFocus"                ,"}N                                :"
	elseif t == 3104111 then return "OLSharpness"                 ,"V[vlX                          :"
	elseif t == 3104113 then return "OLColourMatrix"              ,"J[}gbNX                    :"
	elseif t == 3104114 then return "OLBlackLevel"                ,"x                              :"
	elseif t == 3104117 then return "OLWhiteBalance"              ,"zCgoX                      :"
	elseif t == 3104119 then return "OLRedBias"                   ,"oCAX()                          :"
	elseif t == 3104120 then return "OLBlueBias"                  ,"oCAX()                          :"
	elseif t == 3104122 then return "OLSerialNumber"              ,"VAio[                      :"
	elseif t == 3104131 then return "OLFlashBias"                 ,"tbVoCAX                    :"
	elseif t == 3104137 then return "OLContrast"                  ,"RgXg                          :"
	elseif t == 3104138 then return "OLSharpnessFactor"           ,"Sharpness Factor                      :"
	elseif t == 3104139 then return "OLColourControl"             ,"J[Rg[                    :"
	elseif t == 3104140 then return "OLValidBits"                 ,"Lrbg                            :"
	elseif t == 3104141 then return "OLCoringFilter"              ,"Coring Filter                         :"
	elseif t == 3104142 then return "OLImageWidth"                ,"摜̕                              :"
	elseif t == 3104143 then return "OLImageHeight"               ,"摜̍                            :"
	elseif t == 3104148 then return "OLCompressionRatio"          ,"k                                :"
	elseif t == 3200018 then return "PXExposureTime"              ,"Io                              :"
	elseif t == 3200019 then return "PXFNumber"                   ,"Fl                                   :"
	elseif t == 3200020 then return "PXISOSpeed"                  ,"ISO l                                :"
	elseif t == 3200022 then return "PXExposureBias"              ,"Io␳lE                           :"
	elseif t == 3200025 then return "PXWhiteBalance"              ,"zCgoX                      :"
	elseif t == 3200063 then return "PXLensID"                    ,"Y                            :"
	elseif t == 3200079 then return "PXImageTone"                 ,"摜dグ                            :"
	elseif t == 3300002 then return "EXThumbInfo"                 ,"TlC̑傫                    :"
	elseif t == 3300003 then return "EXThumbSize"                 ,"TlC̃TCY                    :"
	elseif t == 3300004 then return "EXThumbOffset"               ,"TlCւ̃ItZbg              :"
	elseif t == 3300008 then return "EXQualityMode"               ,"Bei                              :"
	elseif t == 3300009 then return "EXImageSize"                 ,"摜TCY                            :"
	elseif t == 3300020 then return "EXISOSensitivity"            ,"ISO x                              :"
	elseif t == 3300025 then return "EXWhiteBalance"              ,"zCgoX                      :"
	elseif t == 3300029 then return "EXFocalLength"               ,"œ_                              :"
	elseif t == 3300031 then return "EXSaturation"                ,"ʓx                                  :"
	elseif t == 3300032 then return "EXContrast"                  ,"RgXg                          :"
	elseif t == 3300033 then return "EXSharpness"                 ,"V[vlX                          :"
	elseif t == 3303584 then return "EXPIM"                       ,"unknown                               :"
	elseif t == 3308192 then return "EXThumbnail"                 ,"unknown                               :"
	elseif t == 3308209 then return "EXWBBias"                    ,"zCgoXoCAX              :"
	elseif t == 3308210 then return "EXFlash"                     ,"unknown                               :"
	elseif t == 3308226 then return "EXObjectDistance"            ,"Ώە̋                          :"
	elseif t == 3308244 then return "EXFlashDistance"             ,"tbV̋                      :"
	elseif t == 3312288 then return "EXRecordMode"                ,"unknown                               :"
	elseif t == 3312289 then return "EXSelfTimer"                 ,"unknown                               :"
	elseif t == 3312290 then return "EXQuality"                   ,"i                                  :"
	elseif t == 3312291 then return "EXFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 3312294 then return "EXTimeZone"                  ,"^C][                          :"
	elseif t == 3312295 then return "EXBestshotMode"              ,"unknown                               :"
	elseif t == 3312308 then return "EXCCDSensitivity"            ,"CCDx                               :"
	elseif t == 3312309 then return "EXColorMode"                 ,"J[[h                          :"
	elseif t == 3312310 then return "EXColorEnhance"              ,"F                                :"
	elseif t == 3312311 then return "EXFilter"                    ,"tB^[                            :"
	elseif t == 3400001 then return "PXOCaptureMode"              ,"Be[h                            :"
	elseif t == 3400002 then return "PXOQualityLevel"             ,"Bei                              :"
	elseif t == 3400003 then return "PXOFocusMode"                ,"tH[JX[h                      :"
	elseif t == 3400004 then return "PXOFlashMode"                ,"tbV                            :"
	elseif t == 3400007 then return "PXOWhiteBalance"             ,"zCgoX                      :"
	elseif t == 3400010 then return "PXODigitalZoom"              ,"fW^Y[                        :"
	elseif t == 3400011 then return "PXOSharpness"                ,"V[vlX                          :"
	elseif t == 3400012 then return "PXOContrast"                 ,"RgXg                          :"
	elseif t == 3400013 then return "PXOSaturation"               ,"ʓx                                  :"
	elseif t == 3400020 then return "PXOISOSpeed"                 ,"ISO x                              :"
	elseif t == 3400023 then return "PXOColorMode"                ,"J[                                :"
	elseif t == 3404096 then return "PXOTimeZone"                 ,"^C][                          :"
	elseif t == 3404097 then return "PXODaylightSavings"          ,"Daylight savings                      :"
	elseif t == 3500002 then return "NKISOSetting"                ,"ISO x                              :"
	elseif t == 3500003 then return "NKColorMode"                 ,"J[[h                          :"
	elseif t == 3500004 then return "NKQuality"                   ,"Bei                              :"
	elseif t == 3500005 then return "NKWhitebalance"              ,"zCgoX                      :"
	elseif t == 3500006 then return "NKSharpness"                 ,"V[vlX                          :"
	elseif t == 3500007 then return "NKFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 3500008 then return "NKFlashSetting"              ,"VN[h                        :"
	elseif t == 3500009 then return "NKFlashMode"                 ,"tbV[h                      :"
	elseif t == 3500011 then return "NKWhiteBalanceOffset"        ,"zCgoX␳                :"
	elseif t == 3500015 then return "NKISOselection"              ,"ISO x̑I                        :"
	elseif t == 3500017 then return "NKThumbnailIFDOffset"        ,"unknown                               :"
	elseif t == 3500128 then return "NKImageAdjustment"           ,"摜[h                            :"
	elseif t == 3500129 then return "NKContrastSetting"           ,"K␳                              :"
	elseif t == 3500130 then return "NKAdapter"                   ,"A_v^[                            :"
	elseif t == 3500131 then return "NKLensSetting"               ,"unknown                               :"
	elseif t == 3500132 then return "NKLensInfo"                  ,"Y                            :"
	elseif t == 3500133 then return "NKManualFocusDistance"       ,"}jAtH[JX              :"
	elseif t == 3500134 then return "NKDigitalZoom"               ,"fW^Y[䗦                    :"
	elseif t == 3500136 then return "NKAFFocusPoint"              ,"tH[JXGA                      :"
	elseif t == 3500137 then return "NKShutterMode"               ,"샂[h                            :"
	elseif t == 3500141 then return "NKColorSpace"                ,"Fԏ                            :"
	elseif t == 3500146 then return "NKColorOffset"               ,"F␳l                            :"
	elseif t == 3500149 then return "NKNoiseReduction"            ,"mCY_NV                    :"
	elseif t == 3500152 then return "NKLendID"                    ,"Y ID                             :"
	elseif t == 3500167 then return "NKShotCount"                 ,"Be                              :"
	elseif t == 3500169 then return "NKFinishSetting"             ,"dオݒ                          :"
	elseif t == 3500171 then return "NKDigitalImgProg"            ,"fW^C[WvO            :"
	elseif t == 3600003 then return "NKEQuality"                  ,"Be[h                            :"
	elseif t == 3600004 then return "NKEColorMode"                ,"J[[h                          :"
	elseif t == 3600005 then return "NKEImageAdjustment"          ,"Beݒ                              :"
	elseif t == 3600006 then return "NKECCDSensitivity"           ,"CCD x                              :"
	elseif t == 3600007 then return "NKEWhiteBalance"             ,"zCgoX                      :"
	elseif t == 3600008 then return "NKEFocus"                    ,"unknown                               :"
	elseif t == 3600010 then return "NKEDigitalZoom"              ,"fW^Y[䗦                    :"
	elseif t == 3600011 then return "NKEConverter"                ,"Ro[^                            :"
	elseif t == 3700000 then return "MLTMakerNoteVersion"         ,"o[W                            :"
	elseif t == 3700001 then return "MLTCameraSettingsOld"        ,"unknown                               :"
	elseif t == 3700003 then return "MLTExposureMode"             ,"Io[h                            :"
	elseif t == 3700003 then return "MLTFlashMode"                ,"tbV                            :"
	elseif t == 3700003 then return "MLTWhiteBalance"             ,"zCgoX                      :"
	elseif t == 3700003 then return "MLTImageSize"                ,"摜TCY                            :"
	elseif t == 3700003 then return "MLTImageQuality"             ,"摜i                              :"
	elseif t == 3700003 then return "MLTDriveMode"                ,"hCu[h                        :"
	elseif t == 3700003 then return "MLTMeteringMode"             ,"                              :"
	elseif t == 3700003 then return "MLTFilmSpeed"                ,"ISO Xs[h[h                    :"
	elseif t == 3700003 then return "MLTShutterSpeed"             ,"Vb^[x                        :"
	elseif t == 3700003 then return "MLTAperture"                 ,"Aperture                              :"
	elseif t == 3700003 then return "MLTMacroMode"                ,"}N[h                          :"
	elseif t == 3700003 then return "MLTDigitalZoom"              ,"fW^Y[                        :"
	elseif t == 3700003 then return "MLTExposureCompensation"     ,"Io␳                              :"
	elseif t == 3700003 then return "MLTBracketStep"              ,"Bracket step                          :"
	elseif t == 3700003 then return "MLTunknown16"                ,"unknown                               :"
	elseif t == 3700003 then return "MLTIntervalLength"           ,"ԊԊu ()                         :"
	elseif t == 3700003 then return "MLTIntervalNumber"           ,"Ԋu                                :"
	elseif t == 3700003 then return "MLTFocalLength"              ,"œ_ (35mm Z)                  :"
	elseif t == 3700003 then return "MLTFocusDistance"            ,"Focus distance                        :"
	elseif t == 3700003 then return "MLTFlashFired"               ,"tbV                            :"
	elseif t == 3700003 then return "MLTDate"                     ,"                                    :"
	elseif t == 3700003 then return "MLTTime"                     ,"                                    :"
	elseif t == 3700003 then return "MLTMaxAperture"              ,"Max Aperture                          :"
	elseif t == 3700003 then return "MLTFileNumberMemory"         ,"File number memory                    :"
	elseif t == 3700003 then return "MLTLastFileNumber"           ,"Last file number                      :"
	elseif t == 3700003 then return "MLTWhiteBalanceRed"          ,"zCgoX()                  :"
	elseif t == 3700003 then return "MLTWhiteBalanceGreen"        ,"zCgoX()                  :"
	elseif t == 3700003 then return "MLTWhiteBalanceBlue"         ,"zCgoX()                  :"
	elseif t == 3700003 then return "MLTSaturation"               ,"ʓx                                  :"
	elseif t == 3700003 then return "MLTContrast"                 ,"RgXg                          :"
	elseif t == 3700003 then return "MLTSharpness"                ,"V[vlX                          :"
	elseif t == 3700003 then return "MLTSubjectProgram"           ,"IovO                        :"
	elseif t == 3700003 then return "MLTFlashCompensation"        ,"tbV␳                        :"
	elseif t == 3700003 then return "MLTISOSetting"               ,"ISO l                                :"
	elseif t == 3700003 then return "MLTCameraModel"              ,"f                                :"
	elseif t == 3700003 then return "MLTIntervalMode"             ,"Interval mode                         :"
	elseif t == 3700003 then return "MLTFolderName"               ,"Folder name                           :"
	elseif t == 3700003 then return "MLTColorMode"                ,"J[[h                          :"
	elseif t == 3700003 then return "MLTColorFilter"              ,"J[tB^[                      :"
	elseif t == 3700003 then return "MLTBWFilter"                 ,"tB^[                        :"
	elseif t == 3700003 then return "MLTInternalFlash"            ,"tbV                        :"
	elseif t == 3700003 then return "MLTBrightnessValue"          ,"Pxl                                :"
	elseif t == 3700003 then return "MLTSpotFocusPointX"          ,"œ_ʒu(X)                           :"
	elseif t == 3700003 then return "MLTSpotFocusPointY"          ,"œ_ʒu(Y)                           :"
	elseif t == 3700003 then return "MLTWideFocusZone"            ,"Wide focus zone                       :"
	elseif t == 3700003 then return "MLTFocusMode"                ,"tH[JX[h                      :"
	elseif t == 3700003 then return "MLTFocusArea"                ,"tH[JX͈                        :"
	elseif t == 3700003 then return "MLTDECPosition"              ,"DEC position                          :"
	elseif t == 3700064 then return "MLTComppressImageSize"       ,"摜TCY                            :"
	elseif t == 3700129 then return "MLTThumbnail"                ,"unknown                               :"
	elseif t == 3700136 then return "MLTThumbnailOffset"          ,"unknown                               :"
	elseif t == 3700137 then return "MLTThumbnailLength"          ,"TlC̃TCY                    :"
	elseif t == 3700268 then return "MLTLensID"                   ,"Y                            :"
	elseif t == 3703584 then return "MLTPIMInformation"           ,"Print IM                          :"
	elseif t == 3703840 then return "MLTCameraSettings"           ,"unknown                               :"
	elseif t == 3800002 then return "SGSerialID"                  ,"VAio[                      :"
	elseif t == 3800003 then return "SGDriveMode"                 ,"hCu[h                        :"
	elseif t == 3800004 then return "SGImageSize"                 ,"L^f                            :"
	elseif t == 3800005 then return "SGAFMode"                    ,"AF [h                             :"
	elseif t == 3800006 then return "SGFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 3800007 then return "SGWhiteBalance"              ,"zCgoX                      :"
	elseif t == 3800008 then return "SGExposureMode"              ,"Io[h                            :"
	elseif t == 3800009 then return "SGMeteringMode"              ,"[h                            :"
	elseif t == 3800010 then return "SGFocalLength"               ,"œ_                              :"
	elseif t == 3800011 then return "SGColorSpace"                ,"F                                :"
	elseif t == 3800012 then return "SGExposure"                  ,"Io␳                              :"
	elseif t == 3800013 then return "SGContrast"                  ,"RgXg                          :"
	elseif t == 3800014 then return "SGShadow"                    ,"VhE                              :"
	elseif t == 3800015 then return "SGHighlight"                 ,"nCCg                            :"
	elseif t == 3800016 then return "SGSaturation"                ,"ʓx␳                              :"
	elseif t == 3800017 then return "SGSharpness"                 ,"V[vlX␳                      :"
	elseif t == 3800018 then return "SGX3FillLight"               ,"X3 Fill Light                         :"
	elseif t == 3800020 then return "SGColorCoordination"         ,"J[                            :"
	elseif t == 3800021 then return "SGCustomSettingMode"         ,"ݒ                              :"
	elseif t == 3800022 then return "SGJpegQuality"               ,"JPEG i                             :"
	elseif t == 3800023 then return "SGFirmware"                  ,"t@[EFA                        :"
	elseif t == 3800024 then return "SGSoftware"                  ,"Software                              :"
	elseif t == 3800025 then return "SGAutoBlacket"               ,"I[guPbg                      :"
	elseif t == 4000001 then return "CNMacroMode"                 ,"Be[h                            :"
	elseif t == 4000001 then return "CNSelfTimer"                 ,"Zt^C}[                        :"
	elseif t == 4000001 then return "CNFlash"                     ,"tbV                            :"
	elseif t == 4000001 then return "CNDriveMode"                 ,"hCu[h                        :"
	elseif t == 4000001 then return "CNFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 4000001 then return "CNImageSize"                 ,"摜TCY                            :"
	elseif t == 4000001 then return "CNImageSelect"               ,"C[WZNg                      :"
	elseif t == 4000001 then return "CNDigitalZoom"               ,"fW^Y[                        :"
	elseif t == 4000001 then return "CNContrast"                  ,"RgXg                          :"
	elseif t == 4000001 then return "CNSaturation"                ,"ʓx                                  :"
	elseif t == 4000001 then return "CNSharpness"                 ,"V[vlX                          :"
	elseif t == 4000001 then return "CNISOSensitive"              ,"ISO x                              :"
	elseif t == 4000001 then return "CNMeteringMode"              ,"                              :"
	elseif t == 4000001 then return "CNFocusType"                 ,"tH[JX^Cv                      :"
	elseif t == 4000001 then return "CNAFPoint"                   ,"unknown                               :"
	elseif t == 4000001 then return "CNExposurePorgram"           ,"IovO                        :"
	elseif t == 4000001 then return "CNLensID"                    ,"Y                            :"
	elseif t == 4000001 then return "CNLensMaximum"               ,"őœ_                          :"
	elseif t == 4000001 then return "CNLensMinimum"               ,"ŏœ_                          :"
	elseif t == 4000001 then return "CNLensUnit"                  ,"œ_P(mm)                      :"
	elseif t == 4000001 then return "CNFlashDetailed"             ,"unknown                               :"
	elseif t == 4000001 then return "CNFocusSetting"              ,"tH[JXݒ                        :"
	elseif t == 4000001 then return "CNImageStabilization"        ,"Ԃ␳                            :"
	elseif t == 4000001 then return "CNImageEffect"               ,"F                                :"
	elseif t == 4000001 then return "CNHueBias"                   ,"F␳l                          :"
	elseif t == 4000004 then return "CNWhitebalance"              ,"zCgoX                      :"
	elseif t == 4000004 then return "CNImageNumber"               ,"unknown                               :"
	elseif t == 4000004 then return "CNAFPointUsed"               ,"unknown                               :"
	elseif t == 4000004 then return "CNFlashBias"                 ,"tbV␳x                    :"
	elseif t == 4000004 then return "CNAperture"                  ,"i                                  :"
	elseif t == 4000004 then return "CNExposure"                  ,"Io                              :"
	elseif t == 4000004 then return "CNNDFilter"                  ,"ND tB^[                         :"
	elseif t == 4000006 then return "CNImageType"                 ,"C[W̎                        :"
	elseif t == 4000007 then return "CNFirmware"                  ,"t@[EFA                        :"
	elseif t == 4000009 then return "CNUser"                      ,"LҖ                              :"
	elseif t == 4000012 then return "CNSerial"                    ,"VAio[                      :"
	elseif t == 4000015 then return "CNNoiseReduction"            ,"mCY_NV                    :"
	elseif t == 4000015 then return "CNButtunFunction"            ,"Vb^[/AEbN{^             :"
	elseif t == 4000015 then return "CNMirrorLockUp"              ,"~[bNAbv                    :"
	elseif t == 4000015 then return "CNShutterStep"               ,"Vb^[/i̘Ioݒ             :"
	elseif t == 4000015 then return "CNAFSupliment"               ,"AF ⏕                             :"
	elseif t == 4000015 then return "CNApexPriority"              ,"iD惂[h̃Vb^[x      :"
	elseif t == 4000015 then return "CNAEFunction"                ,"AEuPbgƃLZ@̂    :"
	elseif t == 4000015 then return "CNShutterSynchro"            ,"Vb^[VN                  :"
	elseif t == 4000015 then return "CNAFStopButton"              ,"Y AF Xgbv{^              :"
	elseif t == 4000015 then return "CNFlashMemLimit"             ,"tbV[dʐ              :"
	elseif t == 4000015 then return "CNMenuPosition"              ,"j[{^Aʒu                :"
	elseif t == 4000015 then return "CNSETFunction"               ,"SET {^@̂                      :"
	elseif t == 4000015 then return "CNSensorCleaning"            ,"ZT[N[jO                  :"
	elseif t == 4000160 then return "CNColorTemp"                 ,"Fx                                :"
	elseif t == 4000180 then return "CNColorSpace"                ,"F                                :"
	elseif t == 4600000 then return "FJVersion"                   ,"unknown                               :"
	elseif t == 4604096 then return "FJQuality"                   ,"摜i                              :"
	elseif t == 4604097 then return "FJSharpness"                 ,"V[vlX                          :"
	elseif t == 4604098 then return "FJWhiteBalance"              ,"zCgoX                      :"
	elseif t == 4604099 then return "FJColor"                     ,"F̔Z                              :"
	elseif t == 4604112 then return "FJFlashMode"                 ,"tbV                            :"
	elseif t == 4604113 then return "FJFlashStrength"             ,"tbV␳                        :"
	elseif t == 4604128 then return "FJMacro"                     ,"}N                                :"
	elseif t == 4604129 then return "FJFocusMode"                 ,"tH[JX[h                      :"
	elseif t == 4604144 then return "FJSlowSync"                  ,"X[VN                        :"
	elseif t == 4604145 then return "FJPictureMode"               ,"Be[h                            :"
	elseif t == 4604352 then return "FJContBlacket"               ,"A/uPbg                   :"
	elseif t == 4604864 then return "FJBlurWarning"               ,"Ԃx                            :"
	elseif t == 4604865 then return "FJFocusWarning"              ,"I[gtH[JX̏                :"
	elseif t == 4604866 then return "FJAEWarning"                 ,"Iȍ                        :"
	elseif t == 9900001 then return "KCMode"                      ,"Be[h                            :"

    -- o[W 2.2 ȍ~
	elseif t == 27	    then return ""                            ,"ʕ̖                        :"
	elseif t == 28	    then return ""                            ,"ʒn_̖                        :"
	elseif t == 29	    then return ""                            ,"GPS t                              :"
	elseif t == 30	    then return ""                            ,"GPS ␳                          :"
	elseif t == 31	    then return ""                            ,"ʌ덷                      :"

	-- o[W 2.3 ȍ~
	elseif t == 34864	then return ""                            ,"x                              :"
	elseif t == 34865	then return ""                            ,"Wo͊x                          :"
	elseif t == 34866	then return ""                            ,"Iw                          :"
	elseif t == 34867	then return ""                            ,"ISO Xs[h                          :"
	elseif t == 34868	then return ""                            ,"ISO Xs[heB`[h yyy        :"
	elseif t == 34869	then return ""                            ,"ISO Xs[heB`[h zzz        :"
	elseif t == 42032   then return ""                            ,"JLҖ                        :"
	elseif t == 42033   then return ""                            ,"JVAԍ                    :"
	elseif t == 42034   then return ""                            ,"Y̎dl                      :"
	elseif t == 42035   then return ""                            ,"Y[J[                      :"
	elseif t == 42036   then return ""                            ,"Ỹf                      :"
	elseif t == 42037   then return ""                            ,"YVAԍ                    :"
	elseif t == 42240   then return ""                            ,"ĐK}                            :"

	elseif t == 59932   then return "Padding"                     ,"Padding                               :"
	elseif t == 59933   then return "EXIF OffsetSchema"           ,"EXIF OffsetSchema                     :"

	-- Exiv?
	elseif t == 18246   then return "Rating"                      ,"Rating                                :"
	elseif t == 18249   then return "RatingPercent"               ,"RatingPercent                         :"
	elseif t == 40093   then return "XPAuthor"                    ,"XPAuthor                              :"
	else                     return "UNDEFINED"                   ,"sȃ^O ("..t.."):"

	end
end

function exif()
	local begin = cur()

	rstr ("ByteCode", 2)
	if get("ByteCode") == "MM" then
		little_endian(false)
	else
		little_endian(true)
	end

	cbyte("002A"  ,  2, 0x002A)
	rbyte("ifd_ofs", 4)
	ifd(begin, get("ifd_ofs"))

	-- GfBA߂
	little_endian(false)
end

function ifd(origin, offset, indent)
	local indent = indent or 0
	local tab = string.rep("    ", indent)

	seek(origin + offset)
	rbyte("FieldCount", 2)
	print(tab.."---------------IFD count:"..hexstr(get("FieldCount")).."-----------------")

	local count = get("FieldCount")
	for i=1, count do
		local begin = cur()
		rbyte("Tag",         2)
		rbyte("Type",        2)
		rbyte("Count",       4)
		rbyte("ValueOffset", 4)

		local sz, ty = get_type(get("Type"))
		if get("Count") * sz > 4 then
			seek(get("ValueOffset")+origin)
		else
			seek(cur() - 4)
		end

		if ty == "byte" then
			for j=1, get("Count") do
				local val = rbyte("Byte",                     1)
				print(tab..(select(2, get_tag(get("Tag")))), val)
			end
		elseif ty == "ascii" then
			local val = rstr("Ascii",                         get("Count"))
			print(tab..(select(2, get_tag(get("Tag")))), val)
		elseif ty == "short" then
			for j=1, get("Count") do
				local val = rbyte("Short",                    2)
				print(tab..(select(2, get_tag(get("Tag")))), val)
			end
		elseif ty == "long" then
			for j=1, get("Count") do
				local val = rbyte("Long",                     4)
				print(tab..(select(2, get_tag(get("Tag")))), val)

				-- ̊Kw
				if get_tag(get("Tag")) == "ExifIFDPointer"
				or get_tag(get("Tag")) == "GPSInfoIFDPointer"
				or get_tag(get("Tag")) == "InteroperabilityIFDPointer" then
					local begin = cur()
					ifd(origin, val, indent+1)
					seek(begin)
				end
			end
		elseif ty == "rational" then
			for j=1, get("Count") do
				local num = rbyte("Number",                   4)
				local den = rbyte("Denom",                    4)
				print(tab..(select(2, get_tag(get("Tag")))),  num/den)
			end
		elseif ty == "undefined" then
			local val = rbyte("Undefined",                    get("Count"))
			print(tab..(select(2, get_tag(get("Tag")))), val)
		elseif ty == "slong" then
			for j=1, get("Count") do
				local val = rbyte("Slong",                    4)
				print(tab..(select(2, get_tag(get("Tag")))), val)
			end
		elseif ty == "srational" then
			for j=1, get("Count") do
				local num = rbyte("SNumber",                  4)
				local den = rbyte("SDenom",                   4)
				print(tab..(select(2, get_tag(get("Tag")))), num/den)
			end
		end

		seek(begin + 12)
	end

	rbyte("NextIFD", 4)
	if get("NextIFD") == 0 then
		return
	else
		local begin = cur()
		ifd(origin, get("NextIFD"), indent)
		seek(begin)
	end
end

function jpg()
	cbyte("SOI",           2, 0xffd8)
	print("SOI")
	
	while cur() <= get_size() - 2 do
		local maker = rbyte("Markar", 2)
		if maker == 0xffd9 then -- EOI
			print("EOI")
			break;
		elseif maker == 0xffe0 then
			app0()
		elseif maker == 0xffe1 then
			app1()
		elseif maker == 0xffdb then
			dqt()
		elseif maker == 0xffdd then
			dri()
		elseif maker == 0xffc4 then
			dht()
		elseif maker == 0xffc0 then
			-- x[XC
			sof0()
		elseif maker == 0xffda then
			sos()
		elseif maker == 0xffd0
		or     maker == 0xffd1
		or     maker == 0xffd2
		or     maker == 0xffd3
		or     maker == 0xffd4
		or     maker == 0xffd5
		or     maker == 0xffd6
		or     maker == 0xffd7 then
			-- restart̓XLłɍs
			assert(false, "RST found")
		else
			print("#unknown maker=", hexstr(maker))
			segment()
		end
	end
end

-- enable_print(false)
jpg()

